## Player

An instance of the `Player` class is created when any of the Video.js setup methods are used to initialize a video.

After an instance has been created it can be accessed globally in two ways:

1. By calling `videojs('example_video_1');`
2. By using it directly via `videojs.players.example_video_1;`

## Constructor

#### new Player(tag, optionsopt, readyopt)
`player.js`, `line 255`

  Create an instance of this class.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `tag` | Element |  | The original video DOM element used for configuring options.
  `options` | Object | <optional> | Object of option names and values.
  `ready` | Component~ReadyCallback | <optional> | Ready callback function.

### Extends

- Component

### Members

#### static players :Object
`player.js`, `line 3304`

  Global player list

### Methods

#### static getTagSettings(tag) → {Object}
`player.js`, `line 3167`

  Gets tag settings

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `tag` | Element | The player tag

  ##### Returns:

  Object -

  An object containing all of the settings for a player tag

#### $(selector, contextopt) → {Element|null}
`component.js`, `line 666`

  Find a single DOM element matching a `selector`. This can be within the `Component`s `contentEl()` or another custom context.

  ##### Parameters:

  Name | Type | Attributes | Default | Description
  --- | --- | --- | --- | ---
  `selector` | string |  |  | A valid CSS selector, which will be passed to `querySelector`.
  `context` | Element | string | <optional> | this.contentEl() | A DOM element within which to query. Can also be a selector string in which case the first matching element will get used as context. If missing `this.contentEl()` gets used. If `this.contentEl()` returns nothing it falls back to `document`.

  ##### Returns:

  Element | null -

  the dom element that was found, or null

  Inherited From:
    - Component#$
  See:

    - Information on CSS Selectors

#### $$(selector, contextopt) → {NodeList}
`component.js`, `line 688`

  Finds all DOM element matching a `selector`. This can be within the `Component`s `contentEl()` or another custom context.

  ##### Parameters:

  Name | Type | Attributes | Default | Description
  --- | --- | --- | --- | ---
  `selector` | string |  |  | A valid CSS selector, which will be passed to `querySelectorAll`.
  `context` | Element | string | <optional> | this.contentEl() | A DOM element within which to query. Can also be a selector string in which case the first matching element will get used as context. If missing `this.contentEl()` gets used. If `this.contentEl()` returns nothing it falls back to `document`.

  ##### Returns:

  NodeList -

  a list of dom elements that were found

  Inherited From:
    - Component#$$
  See:

    - Information on CSS Selectors

#### addChild(child, optionsopt, indexopt) → {Component}
`component.js`, `line 377`

  Add a child `Component` inside the current `Component`.

  ##### Parameters:

  Name | Type | Attributes | Default | Description
  --- | --- | --- | --- | ---
  `child` | string | Component |  |  | The name or instance of a child to add.
  `options` | Object | <optional> | {} | The key/value store of options that will get passed to children of the child.
  `index` | number | <optional> | this.children_.length | The index to attempt to add a child into.

  ##### Returns:

  Component -

  The `Component` that gets added as a child. When using a string the `Component` will get created by this process.

  Inherited From:
    - Component#addChild

#### addClass(classToAdd)
`component.js`, `line 712`

  Add a CSS class name to the `Component`s element.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `classToAdd` | string | CSS class name to add

  Inherited From:
    - Component#addClass

#### addRemoteTextTrack(options, manualCleanupopt) → {HtmlTrackElement}
`player.js`, `line 3010`

  Create a remote TextTrack and an HTMLTrackElement. It will automatically removed from the video element whenever the source changes, unless manualCleanup is set to false.

  ##### Parameters:

  Name | Type | Attributes | Default | Description
  --- | --- | --- | --- | ---
  `options` | Object |  |  | Options to pass to HTMLTrackElement during creation. See HTMLTrackElement for object properties that you should use.
  `manualCleanup` | boolean | <optional> | true | if set to false, the TextTrack will be

  ##### Returns:

  HtmlTrackElement -

  the HTMLTrackElement that was created and added to the HtmlTrackElementList and the remote TextTrackList

  Deprecated:
    - The default value of the "manualCleanup" parameter will default to "false" in upcoming versions of Video.js

#### addTextTrack(kindopt, labelopt, languageopt) → {TextTrack|undefined}
`player.js`, `line 2985`

  A helper method for adding a TextTrack to our TextTrackList.

  In addition to the W3C settings we allow adding additional info through options.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `kind` | string | <optional> | the kind of TextTrack you are adding
  `label` | string | <optional> | the label to give the TextTrack label
  `language` | string | <optional> | the language to set on the TextTrack

  ##### Returns:

  TextTrack | undefined -

  the TextTrack that was added or undefined if there is no tech

  See:
    - http://www.w3.org/html/wg/drafts/html/master/embedded-content-0.html#dom-media-addtexttrack

#### aspectRatio(ratioopt) → {string|undefined}
`player.js`, `line 719`

  A getter/setter for the `Player`'s aspect ratio.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `ratio` | string | <optional> | The value to set the `Player's aspect ratio to.

  ##### Returns:

  string | undefined -
  - The current aspect ratio of the `Player` when getting.

          - undefined when setting

#### audioTracks() → {AudioTrackList}
`player.js`, `line 3245`

  Get the AudioTrackList

  ##### Returns:

  AudioTrackList -

  the current audio track list

#### autoplay(valueopt) → {string}
`player.js`, `line 2472`

  Get or set the autoplay attribute.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  - `value` | boolean | <optional> | true means that we should autoplay
         - false means that we should not autoplay

  ##### Returns:

  string -

  The current value of autoplay when getting

#### blur()
`component.js`, `line 1049`

  Remove the focus from this component

  Inherited From:
    - Component#blur

#### buffered() → {TimeRange}
`player.js`, `line 1802`

  Get a TimeRange object with an array of the times of the video that have been downloaded. If you just want the percent of the video that's been downloaded, use bufferedPercent.

  ##### Returns:

  TimeRange -

  A mock TimeRange object (following HTML spec)

  See:

    - Buffered Spec

#### bufferedEnd() → {number}
`player.js`, `line 1831`

  Get the ending time of the last buffered time range This is used in the progress bar to encapsulate all time ranges.

  ##### Returns:

  number -

  The end of the last buffered time range

#### bufferedPercent() → {number}
`player.js`, `line 1820`

  Get the percent (as a decimal) of the video that's been downloaded. This method is not a part of the native HTML video API.

  ##### Returns:

  number -

  A decimal between 0 and 1 representing the percent that is bufferred 0 being 0% and 1 being 100%

#### abstract buildCSSClass() → {string}
`component.js`, `line 586`

  Builds the default DOM class name. Should be overriden by sub-components.

  ##### Returns:

  string -

  The DOM class name for this object.

  Inherited From:
    - Component#buildCSSClass

#### cancelAnimationFrame(id) → {number}
`component.js`, `line 1401`

  Cancels a queued callback passed to Component#requestAnimationFrame (rAF).

  If you queue an rAF callback via Component#requestAnimationFrame, use this function instead of `window.cancelAnimationFrame`. If you don't, your dispose listener will not get cleaned up until Component#dispose!

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `id` | number | The rAF ID to clear. The return value of Component#requestAnimationFrame.

  ##### Returns:

  number -

  Returns the rAF ID that was cleared.

  Inherited From:
    - Component#cancelAnimationFrame
  See:

    - Similar to

#### canPlayType(type) → {string}
`player.js`, `line 2146`

  Check whether the player can play a given mimetype

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `type` | string | The mimetype to check

  ##### Returns:

  string -

  'probably', 'maybe', or '' (empty string)

  See:
    - https://www.w3.org/TR/2011/WD-html5-20110113/video.html#dom-navigator-canplaytype

#### children() → {Array}
`component.js`, `line 323`

  Get an array of all child components

  ##### Returns:

  Array -

  The children

  Inherited From:
    - Component#children

#### clearInterval(intervalId) → {number}
`component.js`, `line 1331`

  Clears an interval that gets created via `window.setInterval` or Component#setInterval. If you set an inteval via Component#setInterval use this function instead of `window.clearInterval`. If you don't your dispose listener will not get cleaned up until Component#dispose!

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `intervalId` | number | The id of the interval to clear. The return value of Component#setInterval or `window.setInterval`.

  ##### Returns:

  number -

  Returns the interval id that was cleared.

  Inherited From:
    - Component#clearInterval
  See:

    - Similar to

#### clearTimeout(timeoutId) → {number}
`component.js`, `line 1268`

  Clears a timeout that gets created via `window.setTimeout` or Component#setTimeout. If you set a timeout via Component#setTimeout use this function instead of `window.clearTimout`. If you don't your dispose listener will not get cleaned up until Component#dispose!

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `timeoutId` | number | The id of the timeout to clear. The return value of Component#setTimeout or `window.setTimeout`.

  ##### Returns:

  number -

  Returns the timeout id that was cleared.

  Inherited From:
    - Component#clearTimeout
  See:

    - Similar to

#### contentEl() → {Element}
`component.js`, `line 292`

  Return the `Component`s DOM element. This is where children get inserted. This will usually be the the same as the element returned in Component#el.

  ##### Returns:

  Element -

  The content element for this `Component`.

  Inherited From:
    - Component#contentEl

#### controls(boolopt) → {boolean}
`player.js`, `line 2596`

  Get or set whether or not the controls are showing.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  - `bool` | boolean | <optional> | true to turn controls on
         - false to turn controls off

  ##### Fires:

  - Player#event:controlsenabled

  ##### Returns:

  boolean -

  The current value of controls when getting

#### createEl() → {Element}
`player.js`, `line 510`

  Create the `Player`'s DOM element.

  ##### Returns:

  Element -

  The DOM element that gets created.

  Overrides:
    - Component#createEl

#### createModal(content, optionsopt) → {ModalDialog}
`player.js`, `line 3142`

  Creates a simple modal dialog (an instance of the ModalDialog component) that immediately overlays the player with arbitrary content and removes itself when closed.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `content` | string | function | Element | Array | null |  | Same as ModalDialog#content's param of the same name. The most straight-forward usage is to provide a string or DOM element.
  `options` | Object | <optional> | Extra options which will be passed on to the ModalDialog.

  ##### Returns:

  ModalDialog -

  the ModalDialog that was created

#### currentDimension(widthOrHeight) → {number}
`component.js`, `line 964`

  Get the width or the height of the `Component` elements computed style. Uses `window.getComputedStyle`.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `widthOrHeight` | string | A string containing 'width' or 'height'. Whichever one you want to get.

  ##### Returns:

  number -

  The dimension that gets asked for or 0 if nothing was set for that dimension.

  Inherited From:
    - Component#currentDimension

#### currentDimensions() → {Component~DimensionObject}
`component.js`, `line 1012`

  Get an object that contains width and height values of the `Component`s computed style.

  ##### Returns:

  Component~DimensionObject -

  The dimensions of the components element

  Inherited From:
    - Component#currentDimensions

#### currentHeight() → {number}
`component.js`, `line 1035`

  Get the height of the `Component`s computed style. Uses `window.getComputedStyle`.

  ##### Returns:

  number -

  height The height of the `Component`s computed style.

  Inherited From:
    - Component#currentHeight

#### currentSource() → {Tech~SourceObject}
`player.js`, `line 2416`

  Returns the current source object.

  ##### Returns:

  Tech~SourceObject -

  The current source object

#### currentSources() → {Array.<Tech~SourceObject>}
`player.js`, `line 2398`

  Returns all of the current source objects.

  ##### Returns:

  Array.<Tech~SourceObject> -

  The current source objects

#### currentSrc() → {string}
`player.js`, `line 2427`

  Returns the fully qualified URL of the current source value e.g. http://mysite.com/video.mp4 Can be used in conjuction with `currentType` to assist in rebuilding the current source object.

  ##### Returns:

  string -

  The current source

#### currentTime(secondsopt) → {number}
`player.js`, `line 1716`

  Get or set the current time (in seconds)

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `seconds` | number | string | <optional> | The time to seek to in seconds

  ##### Returns:

  number -
  - the current time in seconds when getting

#### currentType() → {string}
`player.js`, `line 2439`

  Get the current source type e.g. video/mp4 This can allow you rebuild the current source object so that you could load the same source and tech later

  ##### Returns:

  string -

  The source MIME type

#### currentWidth() → {number}
`component.js`, `line 1025`

  Get the width of the `Component`s computed style. Uses `window.getComputedStyle`.

  ##### Returns:

  number -

  width The width of the `Component`s computed style.

  Inherited From:
    - Component#currentWidth

#### defaultMuted(defaultMutedopt) → {boolean|Player}
`player.js`, `line 1921`

  Get the current defaultMuted state, or turn defaultMuted on or off. defaultMuted indicates the state of muted on intial playback.

        var myPlayer = videojs('some-player-id');

        myPlayer.src("http://www.example.com/path/to/video.mp4");

        // get, should be false
        console.log(myPlayer.defaultMuted());
        // set to true
        myPlayer.defaultMuted(true);
        // get should be true
        console.log(myPlayer.defaultMuted());

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  - `defaultMuted` | boolean | <optional> | true to mute
         - false to unmute

  ##### Returns:

  boolean | Player -
  - true if defaultMuted is on and getting

          - false if defaultMuted is off and getting
          - A reference to the current player when setting

#### defaultPlaybackRate(rateopt) → {number|Player}
`player.js`, `line 2934`

  Gets or sets the current default playback rate. A default playback rate of 1.0 represents normal speed and 0.5 would indicate half-speed playback, for instance. defaultPlaybackRate will only represent what the intial playbackRate of a video was, not not the current playbackRate.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `rate` | number | <optional> | New default playback rate to set.

  ##### Returns:

  number | Player -
  - The default playback rate when getting or 1.0

          - the player when setting

  See:
    - https://html.spec.whatwg.org/multipage/embedded-content.html#dom-media-defaultplaybackrate

#### dimension(dimension, valueopt) → {number}
`player.js`, `line 647`

  A getter/setter for the `Player`'s width & height.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `dimension` | string |  | This string can be:
         - 'width'
         - 'height'
  `value` | number | <optional> | Value for dimension specified in the first argument.

  ##### Returns:

  number -

  The dimension arguments value when getting (width/height).

  Overrides:
    - Component#dimension

#### dimensions(width, height)
`component.js`, `line 868`

  Set both the width and height of the `Component` element at the same time.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `width` | number | string | Width to set the `Component`s element to.
  `height` | number | string | Height to set the `Component`s element to.

  Inherited From:
    - Component#dimensions

#### dispose()
`player.js`, `line 471`

  Destroys the video player and does any necessary cleanup.

  This is especially helpful if you are dynamically adding and removing videos to/from the DOM.

  ##### Fires:

  - Player#event:dispose
  Overrides:
    - Component#dispose

#### duration(secondsopt) → {number}
`player.js`, `line 1748`

  Normally gets the length in time of the video in seconds; in all but the rarest use cases an argument will NOT be passed to the method

  > NOTE: The video must have started loading before the duration can be known, and in the case of Flash, may not be known until the video starts playing.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `seconds` | number | <optional> | The duration of the video to set in seconds

  ##### Fires:

  - Player#event:durationchange

  ##### Returns:

  number -
  - The duration of the video in seconds when getting

#### el() → {Element}
`component.js`, `line 193`

  Get the `Component`s DOM element

  ##### Returns:

  Element -

  The DOM element for this `Component`.

  Inherited From:
    - Component#el

#### enableTouchActivity()
`component.js`, `line 1173`

  This function reports user activity whenever touch events happen. This can get turned off by any sub-components that wants touch events to act another way.

  Report user touch activity when touch events occur. User activity gets used to determine when controls should show/hide. It is simple when it comes to mouse events, because any mouse event should show the controls. So we capture mouse events that bubble up to the player and report activity when that happens. With touch events it isn't as easy as `touchstart` and `touchend` toggle player controls. So touch events can't help us at the player level either.

  User activity gets checked asynchronously. So what could happen is a tap event on the video turns the controls off. Then the `touchend` event bubbles up to the player. Which, if it reported user activity, would turn the controls right back on. We also don't want to completely block touch events from bubbling up. Furthermore a `touchmove` event and anything other than a tap, should not turn controls back on.

  ##### Listens to Events:

  - Component#event:touchstart
  - Component#event:touchmove
  - Component#event:touchend
  - Component#event:touchcancel
  Inherited From:
    - Component#enableTouchActivity

#### ended() → {Boolean}
`player.js`, `line 3353`

  Returns whether or not the player is in the "ended" state.

  ##### Returns:

  Boolean -

  True if the player is in the ended state, false if not.

#### enterFullWindow()
`player.js`, `line 2072`

  When fullscreen isn't supported we can stretch the video container to as wide as the browser will let us.

  ##### Fires:

  - Player#event:enterFullWindow

#### error(erropt) → {MediaError|null}
`player.js`, `line 2702`

  Set or get the current MediaError

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `err` | MediaError | string | number | <optional> | A MediaError or a string/number to be turned into a MediaError

  ##### Fires:

  - Player#event:error

  ##### Returns:

  MediaError | null -

  The current MediaError when getting (or null)

#### exitFullscreen()
`player.js`, `line 2046`

  Return the video to its normal size after having been in full screen mode

  ##### Fires:

  - Player#event:fullscreenchange

#### exitFullWindow()
`player.js`, `line 2116`

  Exit full window

  ##### Fires:

  - Player#event:exitFullWindow

#### flexNotSupported_() → {boolean}
`player.js`, `line 3221`

  Determine wether or not flexbox is supported

  ##### Returns:

  boolean -
  - true if flexbox is supported

          - false if flexbox is not supported

#### fluid(boolopt) → {boolean|undefined}
`player.js`, `line 683`

  A getter/setter/toggler for the vjs-fluid `className` on the `Player`.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  - `bool` | boolean | <optional> | A value of true adds the class.
         - A value of false removes the class.
         - No value will toggle the fluid class.

  ##### Returns:

  boolean | undefined -
  - The value of fluid when getting.

          - `undefined` when setting.

#### focus()
`component.js`, `line 1042`

  Set the focus to this component

  Inherited From:
    - Component#focus

#### fullWindowOnEscKey(event)
`player.js`, `line 2101`

  Check for call to either exit full window or full screen on ESC key

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `event` | string | Event to check for key press

#### getAttribute(attribute) → {string|null}
`component.js`, `line 792`

  Get the value of an attribute on the `Component`s element.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `attribute` | string | Name of the attribute to get the value from.

  ##### Returns:

  string | null -
  - The value of the attribute that was asked for.

          - Can be an empty string on some browsers if the attribute does not exist
            or has no value
          - Most browsers will return null if the attibute does not exist or has
            no value.

  Inherited From:
    - Component#getAttribute
  See:

    - DOM API

#### getCache() → {Object}
`player.js`, `line 1538`

  Get object for cached values.

  ##### Returns:

  Object -

  get the current object cache

#### getChild(name) → {Component|undefined}
`component.js`, `line 349`

  Returns the child `Component` with the given `name`.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `name` | string | The name of the child `Component` to get.

  ##### Returns:

  Component | undefined -

  The child `Component` with the given `name` or undefined.

  Inherited From:
    - Component#getChild

#### getChildById(id) → {Component|undefined}
`component.js`, `line 336`

  Returns the child `Component` with the given `id`.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `id` | string | The id of the child `Component` to get.

  ##### Returns:

  Component | undefined -

  The child `Component` with the given `id` or undefined.

  Inherited From:
    - Component#getChildById

#### getVideoPlaybackQuality() → {Object|undefined}
`player.js`, `line 3045`

  Gets available media playback quality metrics as specified by the W3C's Media Playback Quality API.

  ##### Returns:

  Object | undefined -

  An object with supported media playback quality metrics or undefined if there is no tech or the tech does not support it.

  See:

    - Spec

#### hasClass(classToCheck) → {boolean}
`component.js`, `line 702`

  Check if a component's element has a CSS class name.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `classToCheck` | string | CSS class name to check.

  ##### Returns:

  boolean -
  - True if the `Component` has the class.

          - False if the `Component` does not have the class`

  Inherited From:
    - Component#hasClass

#### hasPlugin(name) → {boolean}
`player.js`, `line 3462`

  Reports whether or not a player has a plugin available.

  This does not report whether or not the plugin has ever been initialized on this player. For that, usingPlugin.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `name` | string | The name of a plugin.

  ##### Returns:

  boolean -

  Whether or not this player has the requested plugin available.

#### hasStarted(hasStarted) → {boolean}
`player.js`, `line 1133`

  Add/remove the vjs-has-started class

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  - `hasStarted` | boolean | true: adds the class
         - false: remove the class

  ##### Fires:

  - Player#event:firstplay

  ##### Returns:

  boolean -

  the boolean value of hasStarted

#### height(valueopt) → {number}
`player.js`, `line 629`

  A getter/setter for the `Player`'s height.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `value` | number | <optional> | The value to set the `Player's heigth to.

  ##### Returns:

  number -

  The current height of the `Player` when getting.

  Overrides:
    - Component#height

#### hide()
`component.js`, `line 753`

  Hide the `Component`s element if it is currently showing by adding the 'vjs-hidden` class name to it.

  Inherited From:
    - Component#hide

#### id() → {string}
`component.js`, `line 302`

  Get this `Component`s ID

  ##### Returns:

  string -

  The id of this `Component`

  Inherited From:
    - Component#id

#### initChildren()
`component.js`, `line 483`

  Add and initialize default child `Component`s based upon options.

  Inherited From:
    - Component#initChildren

#### isAudio(bool) → {boolean}
`player.js`, `line 2955`

  Gets or sets the audio flag

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  - `bool` | boolean | true signals that this is an audio player
         - false signals that this is not an audio player

  ##### Returns:

  boolean -

  The current value of isAudio when getting

#### isFullscreen(isFSopt) → {boolean}
`player.js`, `line 1976`

  Check if the player is in fullscreen mode or tell the player that it is or is not in fullscreen mode.

  > NOTE: As of the latest HTML5 spec, isFullscreen is no longer an official property and instead document.fullscreenElement is used. But isFullscreen is still a valuable property for internal player workings.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `isFS` | boolean | <optional> | Set the players current fullscreen state

  ##### Returns:

  boolean -
  - true if fullscreen is on and getting

          - false if fullscreen is off and getting

#### language(codeopt) → {string}
`player.js`, `line 3081`

  The player's language code NOTE: The language should be set in the player options if you want the the controls to be built with a specific language. Changing the lanugage later will not update controls text.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `code` | string | <optional> | the language code to set the player to

  ##### Returns:

  string -

  The current language code when getting

#### languages() → {Array}
`player.js`, `line 3097`

  Get the player's language dictionary Merge every time, because a newly added plugin might call videojs.addLanguage() at any time Languages specified directly in the player options have precedence

  ##### Returns:

  Array -

  An array of of supported languages

#### load()
`player.js`, `line 2379`

  Begin loading the src data.

#### localize(string, tokensopt, defaultValueopt) → {string}
`component.js`, `line 254`

  Localize a string given the string in english.

  If tokens are provided, it'll try and run a simple token replacement on the provided string. The tokens it loooks for look like `{1}` with the index being 1-indexed into the tokens array.

  If a `defaultValue` is provided, it'll use that over `string`, if a value isn't found in provided language files. This is useful if you want to have a descriptive key for token replacement but have a succinct localized string and not require `en.json` to be included.

  Currently, it is used for the progress bar timing.

      {
        "progress bar timing: currentTime={1} duration={2}": "{1} of {2}"
      }

  It is then used like so:

      this.localize('progress bar timing: currentTime={1} duration{2}',
                    [this.player_.currentTime(), this.player_.duration()],
                    '{1} of {2}');

  Which outputs something like: `01:23 of 24:56`.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `string` | string |  | The string to localize and the key to lookup in the language files.
  `tokens` | Array.<string> | <optional> | If the current item has token replacements, provide the tokens here.
  `defaultValue` | string | <optional> | Defaults to `string`. Can be a default value to use for token replacement if the lookup key is needed to be separate.

  ##### Returns:

  string -

  The localized string or if no localization exists the english string.

  Inherited From:
    - Component#localize

#### loop(valueopt) → {string}
`player.js`, `line 2516`

  Get or set the loop attribute on the video element.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  - `value` | boolean | <optional> | true means that we should loop the video
         - false means that we should not loop the video

  ##### Returns:

  string -

  The current value of loop when getting

#### muted(mutedopt) → {boolean}
`player.js`, `line 1887`

  Get the current muted state, or turn mute on or off

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  - `muted` | boolean | <optional> | true to mute
         - false to unmute

  ##### Returns:

  boolean -
  - true if mute is on and getting

          - false if mute is off and getting

#### name() → {string}
`component.js`, `line 313`

  Get the `Component`s name. The name gets used to reference the `Component` and is set during registration.

  ##### Returns:

  string -

  The name of this `Component`.

  Inherited From:
    - Component#name

#### networkState() → {number}
`player.js`, `line 3375`

  Returns the current state of network activity for the element, from the codes in the list below.

  - NETWORK_EMPTY (numeric value 0) The element has not yet been initialised. All attributes are in their initial states.
  - NETWORK_IDLE (numeric value 1) The element's resource selection algorithm is active and has selected a resource, but it is not actually using the network at this time.
  - NETWORK_LOADING (numeric value 2) The user agent is actively trying to download data.
  - NETWORK_NO_SOURCE (numeric value 3) The element's resource selection algorithm is active, but it has not yet found a resource to use.

  ##### Returns:

  number -

  the current network activity state

  See:
    - https://html.spec.whatwg.org/multipage/embedded-content.html#network-states

#### options(obj) → {Object}
`component.js`, `line 176`

  Deep merge of options objects with new options.

  > Note: When both `obj` and `options` contain properties whose values are objects. The two properties get merged using module:mergeOptions

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `obj` | Object | The object that contains new options.

  ##### Returns:

  Object -

  A new object of `this.options_` and `obj` merged together.

  Inherited From:
    - Component#options
  Deprecated:
    - since version 5

#### pause() → {Player}
`player.js`, `line 1655`

  Pause the video playback

  ##### Returns:

  Player -

  A reference to the player object this function was called on

#### paused() → {boolean}
`player.js`, `line 1666`

  Check if the player is paused or has yet to play

  ##### Returns:

  boolean -
  - false: if the media is currently playing

          - true: if media is not currently playing

#### play() → {Promise|undefined}
`player.js`, `line 1621`

  start media playback

  ##### Returns:

  Promise | undefined -

  Returns a `Promise` if the browser returns one, for most browsers this will return undefined.

#### playbackRate(rateopt) → {number}
`player.js`, `line 2907`

  Gets or sets the current playback rate. A playback rate of 1.0 represents normal speed and 0.5 would indicate half-speed playback, for instance.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `rate` | number | <optional> | New playback rate to set.

  ##### Returns:

  number -

  The current playback rate when getting or 1.0

  See:
    - https://html.spec.whatwg.org/multipage/embedded-content.html#dom-media-playbackrate

#### played() → {TimeRange}
`player.js`, `line 1679`

  Get a TimeRange object representing the current ranges of time that the user has played.

  ##### Returns:

  TimeRange -

  A time range object that represents all the increments of time that have been played.

#### player() → {Player}
`component.js`, `line 159`

  Return the Player that the `Component` has attached to.

  ##### Returns:

  Player -

  The player that this `Component` has attached to.

  Inherited From:
    - Component#player

#### playsinline(valueopt) → {string|Player}
`player.js`, `line 2497`

  Set or unset the playsinline attribute. Playsinline tells the browser that non-fullscreen playback is preferred.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  - `value` | boolean | <optional> | true means that we should try to play inline by default
         - false means that we should use the browser's default playback mode,
           which in most cases is inline. iOS Safari is a notable exception
           and plays fullscreen by default.

  ##### Returns:

  string | Player -
  - the current value of playsinline

          - the player when setting

  See:

    - Spec

#### poster(srcopt) → {string}
`player.js`, `line 2536`

  Get or set the poster image source url

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `src` | string | <optional> | Poster image source URL

  ##### Fires:

  - Player#event:posterchange

  ##### Returns:

  string -

  The current value of poster when getting

#### preload(valueopt) → {string}
`player.js`, `line 2453`

  Get or set the preload attribute

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  - `value` | boolean | <optional> | true means that we should preload
         - false maens that we should not preload

  ##### Returns:

  string -

  The preload attribute value when getting

#### ready() → {Component}
`component.js`, `line 600`

  Bind a listener to the component's ready state. Different from event listeners in that if the ready event has already happened it will trigger the function immediately.

  ##### Returns:

  Component -

  Returns itself; method can be chained.

  Inherited From:
    - Component#ready

#### readyState() → {number}
`player.js`, `line 3396`

  Returns a value that expresses the current state of the element with respect to rendering the current playback position, from the codes in the list below.

  - HAVE_NOTHING (numeric value 0) No information regarding the media resource is available.
  - HAVE_METADATA (numeric value 1) Enough of the resource has been obtained that the duration of the resource is available.
  - HAVE_CURRENT_DATA (numeric value 2) Data for the immediate current playback position is available.
  - HAVE_FUTURE_DATA (numeric value 3) Data for the immediate current playback position is available, as well as enough data for the user agent to advance the current playback position in the direction of playback.
  - HAVE_ENOUGH_DATA (numeric value 4) The user agent estimates that enough data is available for playback to proceed uninterrupted.

  ##### Returns:

  number -

  the current playback rendering state

  See:
    - https://html.spec.whatwg.org/multipage/embedded-content.html#dom-media-readystate

#### remainingTime() → {number}
`player.js`, `line 1785`

  Calculates how much time is left in the video. Not part of the native video API.

  ##### Returns:

  number -

  The time remaining in seconds

#### remoteTextTrackEls() → {HtmlTrackElementList}
`player.js`, `line 3275`

  Get the remote HtmlTrackElementList tracks.

  ##### Returns:

  HtmlTrackElementList -

  The current remote text track element list

#### remoteTextTracks() → {TextTrackList}
`player.js`, `line 3266`

  Get the remote TextTrackList

  ##### Returns:

  TextTrackList -

  The current remote text track list

#### removeAttribute(attribute)
`component.js`, `line 819`

  Remove an attribute from the `Component`s element.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `attribute` | string | Name of the attribute to remove.

  Inherited From:
    - Component#removeAttribute
  See:

    - DOM API

#### removeChild(component)
`component.js`, `line 447`

  Remove a child `Component` from this `Component`s list of children. Also removes the child `Component`s element from this `Component`s element.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `component` | Component | The child `Component` to remove.

  Inherited From:
    - Component#removeChild

#### removeClass(classToRemove)
`component.js`, `line 722`

  Remove a CSS class name from the `Component`s element.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `classToRemove` | string | CSS class name to remove

  Inherited From:
    - Component#removeClass

#### removeRemoteTextTrack(track) → {undefined}
`player.js`, `line 3026`

  Remove a remote TextTrack from the respective TextTrackList and HtmlTrackElementList.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `track` | Object | Remote TextTrack to remove

  ##### Returns:

  undefined -

  does not return anything

#### reportUserActivity(event)
`player.js`, `line 2741`

  Report user activity

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `event` | Object | Event object

#### requestAnimationFrame(fn) → {number}
`component.js`, `line 1368`

  Queues up a callback to be passed to requestAnimationFrame (rAF), but with a few extra bonuses:

  - Supports browsers that do not support rAF by falling back to Component#setTimeout.

  - The callback is turned into a Component~GenericCallback (i.e. bound to the component).

  - Automatic cancellation of the rAF callback is handled if the component is disposed before it is called.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `fn` | Component~GenericCallback | A function that will be bound to this component and executed just before the browser's next repaint.

  ##### Listens to Events:

  - Component#event:dispose

  ##### Returns:

  number -

  Returns an rAF ID that gets used to identify the timeout. It can also be used in Component#cancelAnimationFrame to cancel the animation frame callback.

  Inherited From:
    - Component#requestAnimationFrame
  See:

    - Similar to

#### requestFullscreen()
`player.js`, `line 1995`

  Increase the size of the video to full screen In some browsers, full screen is not supported natively, so it enters "full window mode", where the video fills the browser window. In browsers and devices that support native full screen, sometimes the browser's default controls will be shown, and not the Video.js custom skin. This includes most mobile devices (iOS, Android) and older versions of Safari.

  ##### Fires:

  - Player#event:fullscreenchange

#### reset()
`player.js`, `line 2387`

  Reset the player. Loads the first tech in the techOrder, and calls `reset` on the tech`.

#### scrubbing(isScrubbingopt) → {boolean}
`player.js`, `line 1694`

  Returns whether or not the user is "scrubbing". Scrubbing is when the user has clicked the progress bar handle and is dragging it along the progress bar.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `isScrubbing` | boolean | <optional> | wether the user is or is not scrubbing

  ##### Returns:

  boolean -

  The value of scrubbing when getting

#### seekable() → {TimeRanges}
`player.js`, `line 3367`

  Returns the TimeRanges of the media that are currently available for seeking to.

  ##### Returns:

  TimeRanges -

  the seekable intervals of the media timeline

#### seeking() → {Boolean}
`player.js`, `line 3360`

  Returns whether or not the player is in the "seeking" state.

  ##### Returns:

  Boolean -

  True if the player is in the seeking state, false if not.

#### selectSource(sources) → {Object|boolean}
`player.js`, `line 2190`

  Select source based on tech-order or source-order Uses source-order selection if `options.sourceOrder` is truthy. Otherwise, defaults to tech-order selection

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `sources` | Array | The sources for a media asset

  ##### Returns:

  Object | boolean -

  Object of source and tech order or false

#### setAttribute(attribute, value)
`component.js`, `line 807`

  Set the value of an attribute on the `Component`'s element

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `attribute` | string | Name of the attribute to set.
  `value` | string | Value to set the attribute to.

  Inherited From:
    - Component#setAttribute
  See:

    - DOM API

#### setInterval(fn, interval) → {number}
`component.js`, `line 1300`

  Creates a function that gets run every `x` milliseconds. This function is a wrapper around `window.setInterval`. There are a few reasons to use this one instead though.

  1. It gets cleared via Component#clearInterval when Component#dispose gets called.
  2. The function callback will be a Component~GenericCallback

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `fn` | Component~GenericCallback | The function to run every `x` seconds.
  `interval` | number | Execute the specified function every `x` milliseconds.

  ##### Listens to Events:

  - Component#event:dispose

  ##### Returns:

  number -

  Returns an id that can be used to identify the interval. It can also be be used in Component#clearInterval to clear the interval.

  Inherited From:
    - Component#setInterval
  See:

    - Similar to

#### setTimeout(fn, timeout) → {number}
`component.js`, `line 1238`

  Creates a function that runs after an `x` millisecond timeout. This function is a wrapper around `window.setTimeout`. There are a few reasons to use this one instead though:

  1. It gets cleared via Component#clearTimeout when Component#dispose gets called.
  2. The function callback will gets turned into a Component~GenericCallback

  > Note: You can use `window.clearTimeout` on the id returned by this function. This will cause its dispose listener not to get cleaned up! Please use Component#clearTimeout or Component#dispose.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `fn` | Component~GenericCallback | The function that will be run after `timeout`.
  `timeout` | number | Timeout in milliseconds to delay before executing the specified function.

  ##### Listens to Events:

  - Component#event:dispose

  ##### Returns:

  number -

  Returns a timeout ID that gets used to identify the timeout. It can also get used in Component#clearTimeout to clear the timeout that was set.

  Inherited From:
    - Component#setTimeout
  See:

    - Similar to

#### show()
`component.js`, `line 745`

  Show the `Component`s element if it is hidden by removing the 'vjs-hidden' class name from it.

  Inherited From:
    - Component#show

#### src(sourceopt) → {string|undefined}
`player.js`, `line 2264`

  Get or set the video source.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `source` | Tech~SourceObject | Array.<Tech~SourceObject> | string | <optional> | A SourceObject, an array of SourceObjects, or a string referencing a URL to a media source. It is highly recommended that an object or array of objects is used here, so that source selection algorithms can take the `type` into account.
         If not provided, this method acts as a getter.

  ##### Returns:

  string | undefined -

  If the `source` argument is missing, returns the current source URL. Otherwise, returns nothing/undefined.

#### supportsFullScreen() → {boolean}
`player.js`, `line 1957`

  Check if current tech can support native fullscreen (e.g. with built in controls like iOS, so not our flash swf)

  ##### Returns:

  boolean -

  if native fullscreen is supported

#### tech(safetyopt) → {Tech}
`player.js`, `line 979`

  Return a reference to the current Tech. It will print a warning by default about the danger of using the tech directly but any argument that is passed in will silence the warning.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `safety` | * | <optional> | Anything passed in to silence the warning

  ##### Returns:

  Tech -

  The Tech

#### textTracks() → {TextTrackList}
`player.js`, `line 3255`

  Get the TextTrackList

  ##### Returns:

  TextTrackList -

  the current text track list

#### toggleClass(classToToggle, predicateopt)
`component.js`, `line 737`

  Add or remove a CSS class name from the component's element.

  - `classToToggle` gets added when Component#hasClass would return false.
  - `classToToggle` gets removed when Component#hasClass would return true.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `classToToggle` | string |  | The class to add or remove based on (@link Component#hasClass}
  `predicate` | boolean | Dom~predicate | <optional> | An Dom~predicate function or a boolean

  Inherited From:
    - Component#toggleClass

#### toJSON() → {Object}
`player.js`, `line 3108`

  returns a JavaScript object reperesenting the current track information. DOES not return it as JSON

  ##### Returns:

  Object -

  Object representing the current of track info

#### triggerReady()
`component.js`, `line 621`

  Trigger all the ready listeners for this `Component`.

  ##### Fires:

  - Component#event:ready
  Inherited From:
    - Component#triggerReady

#### userActive(boolopt) → {boolean}
`player.js`, `line 2758`

  Get/set if user is active

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  - `bool` | boolean | <optional> | true if the user is active
         - false if the user is inactive

  ##### Fires:

  - Player#event:useractive
  - Player#event:userinactive

  ##### Returns:

  boolean -

  The current value of userActive when getting

#### usingNativeControls(boolopt) → {boolean}
`player.js`, `line 2656`

  Toggle native controls on/off. Native controls are the controls built into devices (e.g. default iPhone controls), Flash, or other techs (e.g. Vimeo Controls) This should only be set by the current tech, because only the tech knows if it can support native controls

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  - `bool` | boolean | <optional> | true to turn native controls on
         - false to turn native controls off

  ##### Fires:

  - Player#event:usingnativecontrols
  - Player#event:usingcustomcontrols

  ##### Returns:

  boolean -

  The current value of native controls when getting

#### usingPlugin(name) → {boolean}
`player.js`, `line 3476`

  Reports whether or not a player is using a plugin by name.

  For basic plugins, this only reports whether the plugin has ever been initialized on this player.

  ##### Parameters:

  Name | Type | Description
  --- | --- | ---
  `name` | string | The name of a plugin.

  ##### Returns:

  boolean -

  Whether or not this player is using the requested plugin.

#### videoHeight() → {number}
`player.js`, `line 3065`

  Get video height

  ##### Returns:

  number -

  current video height

#### videoTracks() → {VideoTrackList}
`player.js`, `line 3235`

  Get the VideoTrackList

  ##### Returns:

  VideoTrackList -

  the current video track list

#### videoWidth() → {number}
`player.js`, `line 3055`

  Get video width

  ##### Returns:

  number -

  current video width

#### volume(percentAsDecimalopt) → {number}
`player.js`, `line 1855`

  Get or set the current volume of the media

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `percentAsDecimal` | number | <optional> | The new volume as a decimal percent:
          - 0 is muted/0%/off
          - 1.0 is 100%/full
          - 0.5 is half volume or 50%

  ##### Returns:

  number -

  The current volume as a percent when getting

#### width(valueopt) → {number}
`player.js`, `line 616`

  A getter/setter for the `Player`'s width.

  ##### Parameters:

  Name | Type | Attributes | Description
  --- | --- | --- | ---
  `value` | number | <optional> | The value to set the `Player's width to.

  ##### Returns:

  number -

  The current width of the `Player` when getting.

  Overrides:
    - Component#width

### Events

#### beforepluginsetup:$name
`plugin.js`, `line 474`

  Signals that a plugin is about to be set up on a player - by name. The name is the name of the plugin.

  ##### Type:

  - Plugin~PluginEventHash

#### abort
`player.js`, `line 69`

  Fires when the loading of an audio/video is aborted.

  ##### Type:

  - EventTarget~Event

#### beforepluginsetup
`plugin.js`, `line 467`

  Signals that a plugin is about to be set up on a player.

  ##### Type:

  - Plugin~PluginEventHash

#### canplay
`player.js`, `line 1205`

  The media has a readyState of HAVE_FUTURE_DATA or greater.

  ##### Type:

  - EventTarget~Event

#### canplaythrough
`player.js`, `line 1223`

  The media has a readyState of HAVE_ENOUGH_DATA or greater. This means that the entire media file can be played without buffering.

  ##### Type:

  - EventTarget~Event

#### componentresize
`component.js`, `line 920`

  Triggered when a component is resized.

  ##### Type:

  - EventTarget~Event
  Inherited From:
    - Component#event:componentresize

#### controlsdisabled
`player.js`, `line 2623`

  ##### Type:

  - EventTarget~Event

#### controlsenabled
`player.js`, `line 2611`

  ##### Type:

  - EventTarget~Event

#### dispose
`player.js`, `line 472`

  Called when the player is being disposed of.

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - Plugin
  Overrides:
    - Component#event:dispose

#### durationchange
`player.js`, `line 1770`

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - DurationDisplay#updateContent
  - LiveDisplay#updateShowing
  - RemainingTimeDisplay#updateContent

#### emptied
`player.js`, `line 101`

  Fires when the current playlist is empty.

  ##### Type:

  - EventTarget~Event

#### ended
`player.js`, `line 1352`

  Fired when the end of the media resource is reached (currentTime == duration)

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - SeekBar#update

#### enterFullWindow
`player.js`, `line 2087`

  ##### Type:

  - EventTarget~Event

#### error
`player.js`, `line 2726`

  ##### Type:

  - EventTarget~Event

#### exitFullWindow
`player.js`, `line 2128`

  ##### Type:

  - EventTarget~Event

#### firstplay
`player.js`, `line 1305`

  Fired the first time a video is played. Not part of the HLS spec, and this is probably not the best implementation yet, so use sparingly. If you don't have a reason to prevent playback, use `myPlayer.one('play');` instead.

  ##### Type:

  - EventTarget~Event
  Deprecated:
    - As of 6.0 firstplay event is deprecated.

#### fullscreenchange
`player.js`, `line 1488`

  Fired when going in and out of fullscreen.

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - FullscreenToggle#handleFullscreenChange
  - TextTrackDisplay#updateDisplay

#### fullscreenchange
`player.js`, `line 2058`

  ##### Type:

  - EventTarget~Event

#### fullscreenchange
`player.js`, `line 2033`

  ##### Type:

  - EventTarget~Event

#### fullscreenchange
`player.js`, `line 2016`

  ##### Type:

  - EventTarget~Event

#### loadeddata
`player.js`, `line 148`

  Fires when the browser has loaded the current frame of the audio/video.

  ##### Type:

  - event

#### loadeddata
`player.js`, `line 3439`

  Fired when the player has downloaded data at the current playback position

  ##### Type:

  - EventTarget~Event

#### loadedmetadata
`player.js`, `line 132`

  Fires when the browser has loaded meta data for the audio/video.

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - DurationDisplay#updateContent

#### loadedmetadata
`player.js`, `line 3432`

  Fired when the player has initial duration and dimension information

  ##### Type:

  - EventTarget~Event

#### loadstart
`player.js`, `line 1106`

  Fired when the user agent begins looking for media data

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - MuteToggle#update
  - PlaybackRateMenuButton#updateVisibility
  - TextTrackDisplay#preselectTrack
  - TextTrackDisplay#toggleDisplay

#### pause
`player.js`, `line 1327`

  Fired whenever the media has been paused

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - PlayToggle#handlePause

#### play
`player.js`, `line 1166`

  Triggered whenever an Tech#play event happens. Indicates that playback has started or resumed.

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - PlayToggle#handlePlay

#### playing
`player.js`, `line 1242`

  The media is no longer blocked from playback, and has started playing.

  ##### Type:

  - EventTarget~Event

#### pluginsetup
`plugin.js`, `line 482`

  Signals that a plugin has just been set up on a player.

  ##### Type:

  - Plugin~PluginEventHash

#### posterchange
`player.js`, `line 2554`

  This event fires when the poster image is changed on the player.

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - PosterImage#update

#### progress
`player.js`, `line 53`

  Fired while the user agent is downloading media data.

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - LoadProgressBar#update

#### ratechange
`player.js`, `line 180`

  Fires when the playing speed of the audio/video is changed

  ##### Type:

  - event

  ##### Listeners of This Event:

  - PlaybackRateMenuButton#updateLabel
  - PlaybackRateMenuItem#update

#### ready
`component.js`, `line 638`

  Triggered when a `Component` is ready.

  ##### Type:

  - EventTarget~Event
  Inherited From:
    - Component#event:ready

#### resize
`player.js`, `line 196`

  Fires when the video's intrinsic dimensions change

  ##### Type:

  - event

#### seeked
`player.js`, `line 1278`

  Fired when the player has finished jumping to a new time

  ##### Type:

  - EventTarget~Event

#### seeking
`player.js`, `line 1260`

  Fired whenever the player is jumping to a new time

  ##### Type:

  - EventTarget~Event

#### stalled
`player.js`, `line 116`

  Fires when the browser is trying to get media data, but data is not available.

  ##### Type:

  - EventTarget~Event

#### suspend
`player.js`, `line 85`

  Fires when the browser is intentionally not getting media data.

  ##### Type:

  - EventTarget~Event

#### tap
`component.js`, `line 1135`

  Triggered when a `Component` is tapped.

  ##### Type:

  - EventTarget~Event
  Inherited From:
    - Component#event:tap

#### textdata
`player.js`, `line 1523`

  Fires when we get a textdata event from tech

  ##### Type:

  - EventTarget~Event

#### texttrackchange
`player.js`, `line 228`

  Fires when the text track has been changed

  ##### Type:

  - event

  ##### Listeners of This Event:

  - TextTrackDisplay#updateDisplay

#### timeupdate
`player.js`, `line 164`

  Fires when the current playback position has changed.

  ##### Type:

  - event

  ##### Listeners of This Event:

  - CurrentTimeDisplay#updateContent
  - DurationDisplay#updateContent
  - RemainingTimeDisplay#updateContent
  - SeekBar#update

#### timeupdate
`player.js`, `line 3446`

  Fired when the current playback position has changed * During playback this is fired every 15-250 milliseconds, depending on the playback technology in use.

  ##### Type:

  - EventTarget~Event

#### useractive
`player.js`, `line 2769`

  ##### Type:

  - EventTarget~Event

#### userinactive
`player.js`, `line 2796`

  ##### Type:

  - EventTarget~Event

#### usingcustomcontrols
`player.js`, `line 2676`

  player is using the custom HTML controls

  ##### Type:

  - EventTarget~Event

#### usingnativecontrols
`player.js`, `line 2666`

  player is using the native device controls

  ##### Type:

  - EventTarget~Event

#### volumechange
`player.js`, `line 3455`

  Fired when the volume changes

  ##### Type:

  - EventTarget~Event

  ##### Listeners of This Event:

  - MuteToggle#update
  - VolumeBar#updateARIAAttributes

#### volumechange
`player.js`, `line 212`

  Fires when the volume has been changed

  ##### Type:

  - event

#### waiting
`player.js`, `line 1185`

  A readyState change on the DOM element has caused playback to stop.

  ##### Type:

  - EventTarget~Event

#### pluginsetup:$name
`plugin.js`, `line 489`

  Signals that a plugin has just been set up on a player - by name. The name is the name of the plugin.

  ##### Type:

  - Plugin~PluginEventHash